<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: /workplace/avs-device-sdk/CertifiedSender/include/CertifiedSender/CertifiedSender.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_cf27311ab9f4263eef70b28364b95692.html">CertifiedSender</a></li><li class="navelem"><a class="el" href="dir_6df96b283d40d46690d3b0ae2a388197.html">include</a></li><li class="navelem"><a class="el" href="dir_be0c87238b90bffb10ac3007e0c9ceef.html">CertifiedSender</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">CertifiedSender.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_certified_sender_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright 2017-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;).</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * You may not use this file except in compliance with the License.</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * A copy of the License is located at</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     http://aws.amazon.com/apache2.0/</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * or in the &quot;license&quot; file accompanying this file. This file is distributed</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * express or implied. See the License for the specific language governing</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * permissions and limitations under the License.</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#ifndef ALEXA_CLIENT_SDK_CERTIFIEDSENDER_INCLUDE_CERTIFIEDSENDER_CERTIFIEDSENDER_H_</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#define ALEXA_CLIENT_SDK_CERTIFIEDSENDER_INCLUDE_CERTIFIEDSENDER_CERTIFIEDSENDER_H_</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_message_storage_interface_8h.html">CertifiedSender/MessageStorageInterface.h</a>&quot;</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_message_request_8h.html">AVSCommon/AVS/MessageRequest.h</a>&gt;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_a_v_s_connection_manager_interface_8h.html">AVSCommon/SDKInterfaces/AVSConnectionManagerInterface.h</a>&gt;</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_connection_status_observer_interface_8h.html">AVSCommon/SDKInterfaces/ConnectionStatusObserverInterface.h</a>&gt;</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_message_sender_interface_8h.html">AVSCommon/SDKInterfaces/MessageSenderInterface.h</a>&gt;</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_requires_shutdown_8h.html">AVSCommon/Utils/RequiresShutdown.h</a>&gt;</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_retry_timer_8h.html">AVSCommon/Utils/RetryTimer.h</a>&gt;</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_executor_8h.html">AVSCommon/Utils/Threading/Executor.h</a>&gt;</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_customer_data_handler_8h.html">RegistrationManager/CustomerDataHandler.h</a>&gt;</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_customer_data_manager_8h.html">RegistrationManager/CustomerDataManager.h</a>&gt;</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="preprocessor">#include &lt;deque&gt;</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a> {</div><div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="namespacealexa_client_s_d_k_1_1certified_sender.html">   35</a></span>&#160;<span class="keyword">namespace </span>certifiedSender {</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div><div class="line"><a name="l00038"></a><span class="lineno"><a class="line" href="namespacealexa_client_s_d_k_1_1certified_sender.html#a39af047a2cd41297f5fd8920d9290a30">   38</a></span>&#160;<span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="namespacealexa_client_s_d_k_1_1certified_sender.html#a39af047a2cd41297f5fd8920d9290a30">CERTIFIED_SENDER_QUEUE_SIZE_WARN_LIMIT</a> = 25;</div><div class="line"><a name="l00040"></a><span class="lineno"><a class="line" href="namespacealexa_client_s_d_k_1_1certified_sender.html#a824d16f3cf967f2929230d330f66e72c">   40</a></span>&#160;<span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="namespacealexa_client_s_d_k_1_1certified_sender.html#a824d16f3cf967f2929230d330f66e72c">CERTIFIED_SENDER_QUEUE_SIZE_HARD_LIMIT</a> = 50;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;</div><div class="line"><a name="l00056"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1certified_sender_1_1_certified_sender.html">   56</a></span>&#160;<span class="keyword">class </span><a class="code" href="classalexa_client_s_d_k_1_1certified_sender_1_1_certified_sender.html">CertifiedSender</a></div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        : <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html">avsCommon::utils::RequiresShutdown</a></div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        , <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface.html">avsCommon::sdkInterfaces::ConnectionStatusObserverInterface</a></div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        , <span class="keyword">public</span> std::enable_shared_from_this&lt;CertifiedSender&gt;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        , <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler.html">registrationManager::CustomerDataHandler</a> {</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    <span class="keyword">static</span> std::shared_ptr&lt;CertifiedSender&gt; <a class="code" href="classalexa_client_s_d_k_1_1certified_sender_1_1_certified_sender.html#a2635a30a4753cbc28b6c952cc27a623b">create</a>(</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        std::shared_ptr&lt;avsCommon::sdkInterfaces::MessageSenderInterface&gt; messageSender,</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        std::shared_ptr&lt;avsCommon::sdkInterfaces::AVSConnectionManagerInterface&gt; connection,</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;        std::shared_ptr&lt;MessageStorageInterface&gt; storage,</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;        std::shared_ptr&lt;registrationManager::CustomerDataManager&gt; dataManager);</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    <span class="keyword">virtual</span> <a class="code" href="classalexa_client_s_d_k_1_1certified_sender_1_1_certified_sender.html#a608f4f183ba3a796b5f6b3748c792e20">~CertifiedSender</a>();</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    std::future&lt;bool&gt; <a class="code" href="classalexa_client_s_d_k_1_1certified_sender_1_1_certified_sender.html#a4c0706d79717b226ba77d1a9c3280fe6">sendJSONMessage</a>(<span class="keyword">const</span> std::string&amp; jsonMessage);</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1certified_sender_1_1_certified_sender.html#a6cb617379260eb52dfde94f0a41798a9">clearData</a>() <span class="keyword">override</span>;</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    <span class="keyword">class </span>CertifiedMessageRequest : <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html">avsCommon::avs::MessageRequest</a> {</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;        CertifiedMessageRequest(<span class="keyword">const</span> std::string&amp; jsonContent, <span class="keywordtype">int</span> dbId);</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;        <span class="keywordtype">void</span> exceptionReceived(<span class="keyword">const</span> std::string&amp; exceptionMessage) <span class="keyword">override</span>;</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;        <span class="keywordtype">void</span> sendCompleted(</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;            <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_request_observer_interface.html#a29e40517f71dfc83e3159a8f0f489d7b">avsCommon::sdkInterfaces::MessageRequestObserverInterface::Status</a> sendMessageStatus) <span class="keyword">override</span>;</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;        <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_request_observer_interface.html#a29e40517f71dfc83e3159a8f0f489d7b">avsCommon::sdkInterfaces::MessageRequestObserverInterface::Status</a> waitForCompletion();</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;        <span class="keywordtype">int</span> getDbId();</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a350a147e52eb3ad3c1326e6639861066">shutdown</a>();</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;        <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_request_observer_interface.html#a29e40517f71dfc83e3159a8f0f489d7b">avsCommon::sdkInterfaces::MessageRequestObserverInterface::Status</a> m_sendMessageStatus;</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;        <span class="keywordtype">bool</span> m_responseReceived;</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;        std::mutex m_requestMutex;</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;        std::condition_variable m_requestCv;</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;        <span class="keywordtype">int</span> m_dbId;</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;        <span class="keywordtype">bool</span> m_isRequestShuttingDown;</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;    };</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1certified_sender_1_1_certified_sender.html">CertifiedSender</a>(</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;        std::shared_ptr&lt;avsCommon::sdkInterfaces::MessageSenderInterface&gt; messageSender,</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;        std::shared_ptr&lt;avsCommon::sdkInterfaces::AVSConnectionManagerInterface&gt; connection,</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;        std::shared_ptr&lt;MessageStorageInterface&gt; storage,</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;        std::shared_ptr&lt;registrationManager::CustomerDataManager&gt; dataManager,</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;        <span class="keywordtype">int</span> queueSizeWarnLimit = <a class="code" href="namespacealexa_client_s_d_k_1_1certified_sender.html#a39af047a2cd41297f5fd8920d9290a30">CERTIFIED_SENDER_QUEUE_SIZE_WARN_LIMIT</a>,</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;        <span class="keywordtype">int</span> queueSizeHardLimit = <a class="code" href="namespacealexa_client_s_d_k_1_1certified_sender.html#a824d16f3cf967f2929230d330f66e72c">CERTIFIED_SENDER_QUEUE_SIZE_HARD_LIMIT</a>);</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;    <span class="keywordtype">void</span> onConnectionStatusChanged(</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;        <span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface.html#a2e6b08990caa9d1911b01d51d92806b4">avsCommon::sdkInterfaces::ConnectionStatusObserverInterface::Status</a> status,</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;        <span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface.html#aec54cdb601e5f93a516400d99663d11e">avsCommon::sdkInterfaces::ConnectionStatusObserverInterface::ChangedReason</a> reason) <span class="keyword">override</span>;</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;    <span class="keywordtype">bool</span> init();</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;    <span class="keywordtype">bool</span> executeSendJSONMessage(std::string jsonMessage);</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;    <span class="keywordtype">void</span> doShutdown() <span class="keyword">override</span>;</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;    <span class="keywordtype">void</span> mainloop();</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;    <span class="keywordtype">int</span> m_queueSizeWarnLimit;</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;    <span class="keywordtype">int</span> m_queueSizeHardLimit;</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;    std::thread m_workerThread;</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;    <span class="keywordtype">bool</span> m_isShuttingDown;</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;    std::mutex m_mutex;</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;</div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;    std::condition_variable m_workerThreadCV;</div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;    <span class="keywordtype">bool</span> m_isConnected;</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_retry_timer.html">avsCommon::utils::RetryTimer</a> m_retryTimer;</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;    std::deque&lt;std::shared_ptr&lt;CertifiedMessageRequest&gt;&gt; m_messagesToSend;</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;    std::shared_ptr&lt;avsCommon::sdkInterfaces::MessageSenderInterface&gt; m_messageSender;</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;    std::shared_ptr&lt;CertifiedMessageRequest&gt; m_currentMessage;</div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;    <span class="comment">// The connection object we are observing.</span></div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;    std::shared_ptr&lt;avsCommon::sdkInterfaces::AVSConnectionManagerInterface&gt; m_connection;</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;    std::shared_ptr&lt;MessageStorageInterface&gt; m_storage;</div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;</div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1threading_1_1_executor.html">avsCommon::utils::threading::Executor</a> m_executor;</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;    <span class="comment">// A condition variable for the main loop to wait for during back-off.</span></div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;    std::condition_variable m_backoffWaitCV;</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;};</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;}  <span class="comment">// namespace certifiedSender</span></div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;}  <span class="comment">// namespace alexaClientSDK</span></div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;<span class="preprocessor">#endif  // ALEXA_CLIENT_SDK_CERTIFIEDSENDER_INCLUDE_CERTIFIEDSENDER_CERTIFIEDSENDER_H_</span></div><div class="ttc" id="classalexa_client_s_d_k_1_1certified_sender_1_1_certified_sender_html_a608f4f183ba3a796b5f6b3748c792e20"><div class="ttname"><a href="classalexa_client_s_d_k_1_1certified_sender_1_1_certified_sender.html#a608f4f183ba3a796b5f6b3748c792e20">alexaClientSDK::certifiedSender::CertifiedSender::~CertifiedSender</a></div><div class="ttdeci">virtual ~CertifiedSender()</div><div class="ttdef"><b>Definition:</b> CertifiedSender.cpp:134</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface_html_aec54cdb601e5f93a516400d99663d11e"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface.html#aec54cdb601e5f93a516400d99663d11e">alexaClientSDK::avsCommon::sdkInterfaces::ConnectionStatusObserverInterface::ChangedReason</a></div><div class="ttdeci">ChangedReason</div><div class="ttdef"><b>Definition:</b> ConnectionStatusObserverInterface.h:47</div></div>
<div class="ttc" id="_message_storage_interface_8h_html"><div class="ttname"><a href="_message_storage_interface_8h.html">MessageStorageInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html">alexaClientSDK::avsCommon::avs::MessageRequest</a></div><div class="ttdef"><b>Definition:</b> MessageRequest.h:37</div></div>
<div class="ttc" id="_requires_shutdown_8h_html"><div class="ttname"><a href="_requires_shutdown_8h.html">RequiresShutdown.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1threading_1_1_executor_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1threading_1_1_executor.html">alexaClientSDK::avsCommon::utils::threading::Executor</a></div><div class="ttdef"><b>Definition:</b> Executor.h:39</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::ConnectionStatusObserverInterface</a></div><div class="ttdef"><b>Definition:</b> ConnectionStatusObserverInterface.h:28</div></div>
<div class="ttc" id="_a_v_s_connection_manager_interface_8h_html"><div class="ttname"><a href="_a_v_s_connection_manager_interface_8h.html">AVSConnectionManagerInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html">alexaClientSDK::avsCommon::utils::RequiresShutdown</a></div><div class="ttdef"><b>Definition:</b> RequiresShutdown.h:32</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1certified_sender_html_a39af047a2cd41297f5fd8920d9290a30"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1certified_sender.html#a39af047a2cd41297f5fd8920d9290a30">alexaClientSDK::certifiedSender::CERTIFIED_SENDER_QUEUE_SIZE_WARN_LIMIT</a></div><div class="ttdeci">static const int CERTIFIED_SENDER_QUEUE_SIZE_WARN_LIMIT</div><div class="ttdoc">The number of items we can store for sending without emitting a warning. </div><div class="ttdef"><b>Definition:</b> CertifiedSender.h:38</div></div>
<div class="ttc" id="_executor_8h_html"><div class="ttname"><a href="_executor_8h.html">Executor.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1certified_sender_1_1_certified_sender_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1certified_sender_1_1_certified_sender.html">alexaClientSDK::certifiedSender::CertifiedSender</a></div><div class="ttdef"><b>Definition:</b> CertifiedSender.h:56</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1certified_sender_1_1_certified_sender_html_a6cb617379260eb52dfde94f0a41798a9"><div class="ttname"><a href="classalexa_client_s_d_k_1_1certified_sender_1_1_certified_sender.html#a6cb617379260eb52dfde94f0a41798a9">alexaClientSDK::certifiedSender::CertifiedSender::clearData</a></div><div class="ttdeci">void clearData() override</div><div class="ttdef"><b>Definition:</b> CertifiedSender.cpp:316</div></div>
<div class="ttc" id="_customer_data_manager_8h_html"><div class="ttname"><a href="_customer_data_manager_8h.html">CustomerDataManager.h</a></div></div>
<div class="ttc" id="_message_sender_interface_8h_html"><div class="ttname"><a href="_message_sender_interface_8h.html">MessageSenderInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1certified_sender_1_1_certified_sender_html_a4c0706d79717b226ba77d1a9c3280fe6"><div class="ttname"><a href="classalexa_client_s_d_k_1_1certified_sender_1_1_certified_sender.html#a4c0706d79717b226ba77d1a9c3280fe6">alexaClientSDK::certifiedSender::CertifiedSender::sendJSONMessage</a></div><div class="ttdeci">std::future&lt; bool &gt; sendJSONMessage(const std::string &amp;jsonMessage)</div><div class="ttdef"><b>Definition:</b> CertifiedSender.cpp:279</div></div>
<div class="ttc" id="_customer_data_handler_8h_html"><div class="ttname"><a href="_customer_data_handler_8h.html">CustomerDataHandler.h</a></div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_html"><div class="ttname"><a href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></div><div class="ttdoc">Whether or not curl logs should be emitted. </div><div class="ttdef"><b>Definition:</b> AVSConnectionManager.h:37</div></div>
<div class="ttc" id="_connection_status_observer_interface_8h_html"><div class="ttname"><a href="_connection_status_observer_interface_8h.html">ConnectionStatusObserverInterface.h</a></div></div>
<div class="ttc" id="_message_request_8h_html"><div class="ttname"><a href="_message_request_8h.html">MessageRequest.h</a></div></div>
<div class="ttc" id="_retry_timer_8h_html"><div class="ttname"><a href="_retry_timer_8h.html">RetryTimer.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_request_observer_interface_html_a29e40517f71dfc83e3159a8f0f489d7b"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_request_observer_interface.html#a29e40517f71dfc83e3159a8f0f489d7b">alexaClientSDK::avsCommon::sdkInterfaces::MessageRequestObserverInterface::Status</a></div><div class="ttdeci">Status</div><div class="ttdef"><b>Definition:</b> MessageRequestObserverInterface.h:33</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1certified_sender_1_1_certified_sender_html_a2635a30a4753cbc28b6c952cc27a623b"><div class="ttname"><a href="classalexa_client_s_d_k_1_1certified_sender_1_1_certified_sender.html#a2635a30a4753cbc28b6c952cc27a623b">alexaClientSDK::certifiedSender::CertifiedSender::create</a></div><div class="ttdeci">static std::shared_ptr&lt; CertifiedSender &gt; create(std::shared_ptr&lt; avsCommon::sdkInterfaces::MessageSenderInterface &gt; messageSender, std::shared_ptr&lt; avsCommon::sdkInterfaces::AVSConnectionManagerInterface &gt; connection, std::shared_ptr&lt; MessageStorageInterface &gt; storage, std::shared_ptr&lt; registrationManager::CustomerDataManager &gt; dataManager)</div><div class="ttdef"><b>Definition:</b> CertifiedSender.cpp:97</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown_html_a350a147e52eb3ad3c1326e6639861066"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a350a147e52eb3ad3c1326e6639861066">alexaClientSDK::avsCommon::utils::RequiresShutdown::shutdown</a></div><div class="ttdeci">void shutdown()</div><div class="ttdef"><b>Definition:</b> RequiresShutdown.cpp:135</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1registration_manager_1_1_customer_data_handler.html">alexaClientSDK::registrationManager::CustomerDataHandler</a></div><div class="ttdef"><b>Definition:</b> CustomerDataHandler.h:33</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_retry_timer_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_retry_timer.html">alexaClientSDK::avsCommon::utils::RetryTimer</a></div><div class="ttdef"><b>Definition:</b> RetryTimer.h:30</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface_html_a2e6b08990caa9d1911b01d51d92806b4"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_connection_status_observer_interface.html#a2e6b08990caa9d1911b01d51d92806b4">alexaClientSDK::avsCommon::sdkInterfaces::ConnectionStatusObserverInterface::Status</a></div><div class="ttdeci">Status</div><div class="ttdef"><b>Definition:</b> ConnectionStatusObserverInterface.h:33</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1certified_sender_html_a824d16f3cf967f2929230d330f66e72c"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1certified_sender.html#a824d16f3cf967f2929230d330f66e72c">alexaClientSDK::certifiedSender::CERTIFIED_SENDER_QUEUE_SIZE_HARD_LIMIT</a></div><div class="ttdeci">static const int CERTIFIED_SENDER_QUEUE_SIZE_HARD_LIMIT</div><div class="ttdoc">The maximum number of items we can store for sending. </div><div class="ttdef"><b>Definition:</b> CertifiedSender.h:40</div></div>
</div><!-- fragment --></div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
